/**
 * @license
 * Copyright (c) 2019 CANDY LINE INC.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */"use strict";Object.defineProperty(exports,"__esModule",{value:!0}),exports.LwM2MObjectStore=exports.LwM2MClientProxy=exports.RequestHandler=exports.ResourceRepositoryBuilder=exports.Resource=exports.setEmptyValue=void 0;var _get=function e(t,o,r){null===t&&(t=Function.prototype);var n=Object.getOwnPropertyDescriptor(t,o);if(void 0===n){var s=Object.getPrototypeOf(t);return null===s?void 0:e(s,o,r)}if("value"in n)return n.value;var i=n.get;return void 0!==i?i.call(r):void 0},_typeof="function"==typeof Symbol&&"symbol"==typeof Symbol.iterator?function(e){return typeof e}:function(e){return e&&"function"==typeof Symbol&&e.constructor===Symbol&&e!==Symbol.prototype?"symbol":typeof e},_createClass=function(){function r(e,t){for(var o=0;o<t.length;o++){var r=t[o];r.enumerable=r.enumerable||!1,r.configurable=!0,"value"in r&&(r.writable=!0),Object.defineProperty(e,r.key,r)}}return function(e,t,o){return t&&r(e.prototype,t),o&&r(e,o),e}}();require("source-map-support/register");var _child_process2=_interopRequireDefault(require("child_process")),_path2=_interopRequireDefault(require("path")),_fs2=_interopRequireDefault(require("fs")),_crypto2=_interopRequireDefault(require("crypto")),_debug2=_interopRequireDefault(require("debug")),_events=require("events"),_objectCommon=require("./object-common"),_objectSecurity2=_interopRequireDefault(require("./object-security")),_objectServer2=_interopRequireDefault(require("./object-server")),_objectAcl2=_interopRequireDefault(require("./object-acl")),_objectDevice2=_interopRequireDefault(require("./object-device"));function _interopRequireDefault(e){return e&&e.__esModule?e:{default:e}}function _possibleConstructorReturn(e,t){if(!e)throw new ReferenceError("this hasn't been initialised - super() hasn't been called");return!t||"object"!=typeof t&&"function"!=typeof t?e:t}function _inherits(e,t){if("function"!=typeof t&&null!==t)throw new TypeError("Super expression must either be null or a function, not "+typeof t);e.prototype=Object.create(t&&t.prototype,{constructor:{value:e,enumerable:!1,writable:!0,configurable:!0}}),t&&(Object.setPrototypeOf?Object.setPrototypeOf(e,t):e.__proto__=t)}function _classCallCheck(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")}var debug=(0,_debug2.default)("node-red-contrib-lwm2m:lwm2m-common"),DEFAULT_REPO={0:_objectSecurity2.default,1:_objectServer2.default,2:_objectAcl2.default,3:_objectDevice2.default},emptyValue="",getEmptyValue=(exports.setEmptyValue=function(e){emptyValue=e},function(e){return"auto"===emptyValue?e:emptyValue}),isEmpty=function(e){return""===e||null==e},resolveValue=function(e,t){return isEmpty(e)?getEmptyValue(t):e||t},Resource=exports.Resource=function(){function a(e){var t=1<arguments.length&&void 0!==arguments[1]?arguments[1]:_objectCommon.LWM2M_TYPE.UNDEFINED,o=2<arguments.length&&void 0!==arguments[2]?arguments[2]:_objectCommon.ACL.DEFAULT,r=3<arguments.length&&void 0!==arguments[3]?arguments[3]:null,n=4<arguments.length&&void 0!==arguments[4]?arguments[4]:null;if(_classCallCheck(this,a),"object"===(void 0===e?"undefined":_typeof(e))?(this.id=e.id,this.type=_objectCommon.LWM2M_TYPE.toType(e.type),this.acl=_objectCommon.ACL.toValue(e.acl),this.value=e.value,this.sensitive=void 0===e.sensitive||null===e.sensitive?void 0:!!e.sensitive):(this.id=e,this.type=_objectCommon.LWM2M_TYPE.toType(t),this.acl=_objectCommon.ACL.toValue(o),this.value=r,this.sensitive=null==n?void 0:!!n),_objectCommon.LWM2M_TYPE.FUNCTION===this.type&&(_objectCommon.ACL.isAllowed(this.acl,_objectCommon.ACL.EXECUTABLE)||(this.acl|=_objectCommon.ACL.EXECUTABLE),delete this.sensitive,delete this.value),!this.value)switch(this.type){case _objectCommon.LWM2M_TYPE.INTEGER:case _objectCommon.LWM2M_TYPE.FLOAT:this.value=resolveValue(this.value,0);break;case _objectCommon.LWM2M_TYPE.BOOLEAN:this.value=resolveValue(this.value,!1);break;case _objectCommon.LWM2M_TYPE.STRING:this.value="";break;case _objectCommon.LWM2M_TYPE.OPAQUE:this.value=Buffer.from([]);break;case _objectCommon.LWM2M_TYPE.OBJECT_LINK:this.value={objectId:0,objectInstanceId:0}}this.initialized=!1}return _createClass(a,[{key:"destroy",value:function(){var e=this;if(this.value&&"function"==typeof this.value.fini)try{return Promise.all([this.value.fini()]).then(function(){return e})}catch(e){delete this.value}return Promise.resolve(this)}},{key:"init",value:function(){var t=this;this.initialized=!0;var e=void 0;if(this.value&&"function"==typeof this.value.init?e=this.value.init.bind(this.value):"function"==typeof this.value&&(e=this.value.bind(this.value)),e)try{return Promise.all([e()]).then(function(e){return a.from(e[0])}).then(function(e){return"function"!=typeof t.value.get&&("function"==typeof e.value?t.value=e.value.bind(e.value):t.value=e.value),Promise.resolve(t)})}catch(e){delete this.value}return Promise.resolve(this)}},{key:"isExecutable",value:function(){return _objectCommon.ACL.isAllowed(this.acl,_objectCommon.ACL.EXECUTABLE)}},{key:"isDeletable",value:function(){return _objectCommon.ACL.isAllowed(this.acl,_objectCommon.ACL.DELETABLE)}},{key:"toValue",value:function(){var e=0<arguments.length&&void 0!==arguments[0]&&arguments[0];if(!this.isExecutable()){if(!_objectCommon.ACL.isAllowed(this.acl,_objectCommon.ACL.READABLE)&&!e)throw{status:_objectCommon.COAP_ERROR.COAP_405_METHOD_NOT_ALLOWED};if(this.value&&"function"==typeof this.value.get)try{return this.value.get()}catch(e){throw{status:e.status||_objectCommon.COAP_ERROR.COAP_500_INTERNAL_SERVER_ERROR}}return this.value}}},{key:"update",value:function(e,t){var o=this;if(this.isExecutable())return Promise.reject({status:_objectCommon.COAP_ERROR.COAP_405_METHOD_NOT_ALLOWED,message:"Method Not Allowed (executable)"});if(t&&!_objectCommon.ACL.isAllowed(this.acl,_objectCommon.ACL.WRITABLE))return Promise.reject({status:_objectCommon.COAP_ERROR.COAP_401_UNAUTHORIZED,message:"Unauthorized (insufficient permission)"});if(this.value&&!Buffer.isBuffer(this.value)&&"function"==typeof this.value.set)try{var r=void 0;if(e instanceof a){var n=e.toValue(!0);r=this.value.set(void 0===n?null:n)}else r=void 0===e?this.value.set(null):this.value.set(e);return r&&"function"==typeof r.then?r:Promise.resolve()}catch(e){return Promise.reject({status:e.status||_objectCommon.COAP_ERROR.COAP_500_INTERNAL_SERVER_ERROR,message:e.stack})}return(e instanceof a?Promise.resolve(e):a.from(e)).then(function(e){if(o.type===e.type)o.value=e.value;else switch(o.type){case _objectCommon.LWM2M_TYPE.STRING:o.value=e.toString();break;case _objectCommon.LWM2M_TYPE.OPAQUE:o.value=e.toBuffer();break;case _objectCommon.LWM2M_TYPE.INTEGER:o.value=e.toInteger(!0);break;case _objectCommon.LWM2M_TYPE.FLOAT:o.value=e.toFloat(!0);break;case _objectCommon.LWM2M_TYPE.BOOLEAN:o.value=e.toBoolean(!0);break;case _objectCommon.LWM2M_TYPE.OBJECT_LINK:case _objectCommon.LWM2M_TYPE.MULTIPLE_RESOURCE:return Promise.reject({status:_objectCommon.COAP_ERROR.COAP_400_BAD_REQUEST,message:"Bad Request"})}})}},{key:"toString",value:function(){var e=this.toValue();switch(this.type){case _objectCommon.LWM2M_TYPE.STRING:return e;case _objectCommon.LWM2M_TYPE.BOOLEAN:return e?"1":"0";default:return null==e?null:e.toString()}}},{key:"toBuffer",value:function(){var e=this.toValue();return a.toBuffer(e)}},{key:"bufferToFloat",value:function(e){return 4===e.length?e.readFloatBE(0):8===e.length?e.readDoubleBE(0):0}},{key:"toFloat",value:function(){var e=0<arguments.length&&void 0!==arguments[0]&&arguments[0],t=this.toValue();if(e&&isEmpty(t))return getEmptyValue(0);switch(this.type){case _objectCommon.LWM2M_TYPE.FLOAT:case _objectCommon.LWM2M_TYPE.INTEGER:return t;case _objectCommon.LWM2M_TYPE.BOOLEAN:return t?1:0;case _objectCommon.LWM2M_TYPE.OPAQUE:if("number"==typeof t)return t;if(Buffer.isBuffer(t))return this.bufferToFloat(t);if("string"==typeof t){if(0==t.indexOf("hex:"))return this.bufferToFloat(Buffer.from(t.substring(4),"hex"));if(0==t.indexOf("base64:"))return this.bufferToFloat(Buffer.from(t.substring(4),"base64"))}return parseFloat(t);default:return t?parseFloat(t.toString()):0}}},{key:"toInteger",value:function(){var e=0<arguments.length&&void 0!==arguments[0]&&arguments[0],t=this.toValue();if(e&&isEmpty(t))return getEmptyValue(0);switch(this.type){case _objectCommon.LWM2M_TYPE.FLOAT:return parseInt(t);case _objectCommon.LWM2M_TYPE.INTEGER:return t;case _objectCommon.LWM2M_TYPE.BOOLEAN:return t?1:0;case _objectCommon.LWM2M_TYPE.OPAQUE:return"number"==typeof t?parseInt(t):Buffer.isBuffer(t)?parseInt(t.toString("hex"),16):("string"==typeof t&&(0==t.indexOf("hex:")?t.substring(4):0==t.indexOf("base64:")&&Buffer.from(t.substring(4),"base64").toString("hex")),parseInt(t));default:return t?parseInt(t.toString()):0}}},{key:"toBoolean",value:function(){var e=0<arguments.length&&void 0!==arguments[0]&&arguments[0],t=this.toValue();if(e&&isEmpty(t))return getEmptyValue(!1);switch(this.type){case _objectCommon.LWM2M_TYPE.BOOLEAN:return t;case _objectCommon.LWM2M_TYPE.OPAQUE:return!!t[0];case _objectCommon.LWM2M_TYPE.STRING:return!(!t||"0"===t);default:return!!t}}},{key:"serialize",value:function(){var e=0<arguments.length&&void 0!==arguments[0]?arguments[0]:Buffer.from([]);if(!_objectCommon.ACL.isAllowed(this.acl,_objectCommon.ACL.READABLE))return e;var t=[];if("number"!=typeof this.id)throw Error("Cannot seriazlize a resource object without Resource ID");t.push(255&this.id),t.push(this.id>>8&255),t.push(this.type);var o=this.toValue();switch(this.type){case _objectCommon.LWM2M_TYPE.STRING:o=Buffer.from((o||"")+"");break;case _objectCommon.LWM2M_TYPE.INTEGER:case _objectCommon.LWM2M_TYPE.FLOAT:o=Buffer.from(resolveValue(o,0)+"");break;case _objectCommon.LWM2M_TYPE.OPAQUE:o=a.toBuffer(o);break;case _objectCommon.LWM2M_TYPE.BOOLEAN:var r=resolveValue(o,!1);o="boolean"==typeof r?Buffer.from([r?1:0]):Buffer.from(r);break;case _objectCommon.LWM2M_TYPE.OBJECT_LINK:o&&void 0!==o.objectId&&void 0!==o.objectInstanceId||(o.objectId=65535,o.objectInstanceId=65535),o=Buffer.from([255&o.objectId,o.objectId>>8&255,255&o.objectInstanceId,o.objectInstanceId>>8&255]);break;case _objectCommon.LWM2M_TYPE.MULTIPLE_RESOURCE:var n=Object.keys(o),s=Buffer.from([255&n.length,n.length>>8&255]);n.forEach(function(e){var t=o[e];if(!(t instanceof a))throw{status:_objectCommon.COAP_ERROR.COAP_400_BAD_REQUEST,message:"Invalid Multiple Resource Value"};t.id=parseInt(e),s=t.serialize(s)}),o=s;break;case _objectCommon.LWM2M_TYPE.FUNCTION:return e;default:throw{status:_objectCommon.COAP_ERROR.COAP_501_NOT_IMPLEMENTED,message:"Unknown Type: ["+this.type+"] => "+JSON.stringify(this.toJSON())}}return t.push(255&o.length),t.push(o.length>>8&255),Buffer.concat([e,Buffer.from(t),o])}},{key:"toJSON",value:function(){var t=this.toValue(!0);if(this.type===_objectCommon.LWM2M_TYPE.MULTIPLE_RESOURCE){var o={};Object.keys(t).forEach(function(e){o[e]=t[e].toJSON()}),t=o}var e={type:_objectCommon.LWM2M_TYPE.toString(this.type),acl:_objectCommon.ACL.toString(this.acl)};return void 0!==this.sensitive&&(e.sensitive=this.sensitive),void 0!==t&&(e.value=t),e}},{key:"clone",value:function(){return a.build(this)}}],[{key:"parse",value:function(e,t){if(!Buffer.isBuffer(t))return null;var o=t[0]+(t[1]<<8&65280),r=t[2],n=t[3]+(t[4]<<8&65280),s=t.slice(5,5+n),i=void 0;switch(r){case _objectCommon.LWM2M_TYPE.STRING:i=s.toString();break;case _objectCommon.LWM2M_TYPE.OPAQUE:i=s;break;case _objectCommon.LWM2M_TYPE.INTEGER:i=0===s.length?getEmptyValue(0):parseInt(s.toString());break;case _objectCommon.LWM2M_TYPE.FLOAT:i=0===s.length?getEmptyValue(0):parseFloat(s.toString());break;case _objectCommon.LWM2M_TYPE.BOOLEAN:i=0===s.length?getEmptyValue(!1):1===s[0];break;case _objectCommon.LWM2M_TYPE.OBJECT_LINK:i={objectId:s[0]+(s[1]<<8&65280),objectInstanceId:s[2]+(s[3]<<8&65280)};break;case _objectCommon.LWM2M_TYPE.MULTIPLE_RESOURCE:for(i={};0<s.length;)s=a.parse(i,s)}return e[o]=a.build(o,r,null,i),t.slice(5+n)}},{key:"toBuffer",value:function(e){if(e&&"object"===(void 0===e?"undefined":_typeof(e))&&Array.isArray(e.data)&&"Buffer"===e.type)return Buffer.from(e.data);if(Array.isArray(e))return Buffer.from(e);if(Buffer.isBuffer(e))return"boolean"==typeof e?Buffer.from([e?0:1]):e;var t=e+"",o=0==t.indexOf("base64:")?"base64":0==t.indexOf("hex:")?"hex":"";if(o)return Buffer.from(t.substring(1+t.indexOf(":")),o);if("number"!=typeof e)return"object"===(void 0===e?"undefined":_typeof(e))?Buffer.from(JSON.stringify(e)):Buffer.from(e+"");if(e%1==0)return Buffer.from([e]);var r=new Float32Array(1);return r[0]=e,Buffer.from(r.buffer)}},{key:"build",value:function(e){return new a(e,1<arguments.length&&void 0!==arguments[1]?arguments[1]:_objectCommon.LWM2M_TYPE.UNDEFINED,2<arguments.length&&void 0!==arguments[2]?arguments[2]:_objectCommon.ACL.DEFAULT,3<arguments.length&&void 0!==arguments[3]?arguments[3]:null,4<arguments.length&&void 0!==arguments[4]&&arguments[4])}},{key:"isRawMultipleResourceObject",value:function(e){if("object"!==(void 0===e?"undefined":_typeof(e))||e instanceof a)return!1;var t=Object.keys(e);return t.length===t.filter(function(e){return e.match(/^\d+$/)}).length}},{key:"from",value:function(e){if(e instanceof a&&e.initialized)return Promise.resolve(e);switch(void 0===e?"undefined":_typeof(e)){case"string":return a.build({type:"STRING",value:e||""}).init();case"number":return a.build({type:0<=(e+"").indexOf(".")?"FLOAT":"INTEGER",value:resolveValue(e,0)}).init();case"boolean":return a.build({type:"BOOLEAN",value:resolveValue(e,!!e)}).init();default:if(Buffer.isBuffer(e))return a.build({type:"OPAQUE",value:e||Buffer.from([])}).init();if(Array.isArray(e))return Promise.all(e.map(function(e){return a.from(e)})).then(function(e){var t=e.reduce(function(e,t,o){return e[o]=t,e},{});return a.build({type:"MULTIPLE_RESOURCE",value:t}).init()});if(a.isRawMultipleResourceObject(e)){var r=Object.keys(e),t=Object.values(e);return Promise.all(t.map(function(e){return a.from(e)})).then(function(e){var t=e.reduce(function(e,t,o){return e[r[o]]=t,e},{});return a.build({type:"MULTIPLE_RESOURCE",value:t}).init()})}return e&&_objectCommon.LWM2M_TYPE.toType(e.type)===_objectCommon.LWM2M_TYPE.MULTIPLE_RESOURCE?a.build(e).init().then(function(t){var e=["(error)"];try{e=t.toValue(!0)}catch(e){}var o={};return(Array.isArray(e)?Promise.all(e.map(function(e){return a.from(e)})).then(function(e){var t=e.reduce(function(e,t,o){return e[o]=t,e},{});return Promise.resolve(t)}):Promise.all(Object.keys(e||{}).map(function(t){return a.from(e[t]).then(function(e){return o[t]=e})})).then(function(){return Promise.resolve(o)})).then(function(e){return a.build({type:"MULTIPLE_RESOURCE",acl:t.acl,sensitive:t.sensitive,value:e}).init()})}):a.build(e).init()}}}]),a}(),CredUtils=function(){function n(){_classCallCheck(this,n)}return _createClass(n,null,[{key:"decryptCredentials",value:function(e,t){var o=t.$,r=Buffer.from(o.substring(0,32),"hex"),n=_crypto2.default.createHash("sha256").update(e).digest(),s=o.substring(32),i=_crypto2.default.createDecipheriv("aes-256-ctr",n,r),a=i.update(s,"base64","utf8")+i.final("utf8");return JSON.parse(a)}},{key:"encryptCredentials",value:function(e,t){var o=_crypto2.default.randomBytes(16),r=_crypto2.default.createHash("sha256").update(e).digest(),n=_crypto2.default.createCipheriv("aes-256-ctr",r,o);return{$:o.toString("hex")+n.update(JSON.stringify(t),"utf8","base64")+n.final("base64")}}},{key:"loadCredentials",value:function(t,e){if(!t||!e)return null;try{var o=_fs2.default.readFileSync(t,"utf-8"),r=JSON.parse(o.toString());return n.decryptCredentials(e,r)}catch(e){return n.deleteCredentials(t),null}}},{key:"saveCredentials",value:function(e,t,o){if(!e||!t)return!1;var r=n.encryptCredentials(t,o);return _fs2.default.writeFileSync(e,JSON.stringify(r),"utf-8"),!0}},{key:"deleteCredentials",value:function(e){try{return _fs2.default.unlinkSync(e),!0}catch(e){return!1}}}]),n}(),ResourceRepositoryBuilder=exports.ResourceRepositoryBuilder=function(){function i(){var e=0<arguments.length&&void 0!==arguments[0]?arguments[0]:[],t=!(1<arguments.length&&void 0!==arguments[1])||arguments[1],s=this,o=2<arguments.length&&void 0!==arguments[2]?arguments[2]:"",r=3<arguments.length&&void 0!==arguments[3]?arguments[3]:"";_classCallCheck(this,i),Array.isArray(e)||(e=[e]);var n=CredUtils.loadCredentials(o,r);n&&(e.splice(0,0,n),this.credentialsLoaded=!0),t&&e.push(DEFAULT_REPO),this.json={},e.forEach(function(t){Object.keys(t).forEach(function(n){if(/^\d+$/.test(n)){var e=t[n];s.json[n]||(s.json[n]={}),Object.keys(e).forEach(function(o){var r=e[o];s.json[n][o]||(s.json[n][o]={}),Object.keys(r).forEach(function(e){var t=r[e];s.json[n][o][e]||(s.json[n][o][e]=t)})})}})})}return _createClass(i,[{key:"build",value:function(){var e=this,t=0<arguments.length&&void 0!==arguments[0]?arguments[0]:{},c={extraObjectIdArray:[],hideSensitiveInfo:t.hideSensitiveInfo,definitions:t.definitions||{}},l=[],a=[-1,-1,[]],o=function(e,t){return e-t},u=function(e){return parseInt(e)};Object.keys(this.json).map(u).sort(o).forEach(function(s){var t=e.json[s];if("object"===(void 0===t?"undefined":_typeof(t))){(s=_objectCommon.LWM2M_OBJECT_ID.toType(s,s))>_objectCommon.LWM2M_OBJECT_ID.DEVICE&&c.extraObjectIdArray.push(s),c.definitions[s]||(c.definitions[s]={});var i=c.definitions[s];debug("[build] objectDefinition(id:"+s+") => "+JSON.stringify(i)),Object.keys(t).map(u).sort(o).forEach(function(r){var e=t[r];if("object"===(void 0===e?"undefined":_typeof(e))){var n="/"+s+"/"+r;Object.keys(e).map(u).sort(o).forEach(function(o){l.push(Resource.from(e[o]).then(function(e){switch(s){case _objectCommon.LWM2M_OBJECT_ID.SECURITY:a[_objectCommon.LWM2M_OBJECT_ID.SECURITY]<0&&10===o&&e.toInteger()<1&&(a[_objectCommon.LWM2M_OBJECT_ID.SECURITY]=r);break;case _objectCommon.LWM2M_OBJECT_ID.SERVER:a[_objectCommon.LWM2M_OBJECT_ID.SERVER]<0&&0===o&&e.toInteger()<1&&(a[_objectCommon.LWM2M_OBJECT_ID.SERVER]=r);break;case _objectCommon.LWM2M_OBJECT_ID.ACL:3===o&&e.toInteger()<1&&a[_objectCommon.LWM2M_OBJECT_ID.ACL].push(r)}var t=n+"/"+o;e.id=o,c[t]=e,i[o]||(debug("[build] <NEW> Defining Object ID: "+s+", Resource ID: "+o),i[o]=e.clone())}))})}})}});var r=function(e){var o=c.definitions[e],r=_objectCommon.LWM2M_OBJECT_ID.toType(e,e);r>_objectCommon.LWM2M_OBJECT_ID.DEVICE&&!c.extraObjectIdArray.includes(r)&&(debug("[build] Add extraObjectIdArray Object ID: "+r),c.extraObjectIdArray.push(r));var t=function(e){var t=parseInt(e);o[t]instanceof Resource||l.push(Resource.from(o[t]).then(function(e){debug("[build] <UPDATE> Defining Object ID: "+r+", Resource ID: "+t+", resource: "+JSON.stringify(e)),o[t]=e}))},n=!0,s=!1,i=void 0;try{for(var a,u=Object.keys(o)[Symbol.iterator]();!(n=(a=u.next()).done);n=!0){t(a.value)}}catch(e){s=!0,i=e}finally{try{!n&&u.return&&u.return()}finally{if(s)throw i}}},n=!0,s=!1,i=void 0;try{for(var _,f=Object.keys(c.definitions)[Symbol.iterator]();!(n=(_=f.next()).done);n=!0){r(_.value)}}catch(e){s=!0,i=e}finally{try{!n&&f.return&&f.return()}finally{if(s)throw i}}return Promise.all(l).then(function(){return!e.credentialsLoaded&&e.json[_objectCommon.LWM2M_OBJECT_ID.SECURITY]&&0<=a[_objectCommon.LWM2M_OBJECT_ID.SECURITY]&&e._applyOptionsToSecurityObject(a,t,c),!e.credentialsLoaded&&e.json[_objectCommon.LWM2M_OBJECT_ID.SERVER]&&0<=a[_objectCommon.LWM2M_OBJECT_ID.SERVER]&&e._applyOptionsToServerObject(a,t,c),e.json[_objectCommon.LWM2M_OBJECT_ID.ACL]&&0<a[_objectCommon.LWM2M_OBJECT_ID.ACL].length&&e._applyOptionsToACLObject(a,t,c),c.toJSONString=function(){var s={version:"1.0.0"};return Object.keys(c).forEach(function(e){var t=e.split("/").splice(1),o=t[0];if(!isNaN(parseInt(o))){var r=t[1];if(!isNaN(parseInt(r))){var n=t[2];isNaN(parseInt(n))||(s[o]||(s[o]={}),s[o][r]||(s[o][r]={}),s[o][r][n]=c[e])}}}),JSON.stringify(s)},Promise.resolve(c)})}},{key:"_applyOptionsToSecurityObject",value:function(e,t,o){var r="/"+_objectCommon.LWM2M_OBJECT_ID.SECURITY+"/"+e[_objectCommon.LWM2M_OBJECT_ID.SECURITY],n="coap://";if(t.enableDTLS){if(!t.pskIdentity||!t.presharedKey)throw Error("Cannot start in DTLS mode becasue of invalid PSK configuration");n="coaps://",o[r+"/2"].value=0,o[r+"/3"]=Resource.build({type:"OPAQUE",value:t.pskIdentity}),o[r+"/5"]=Resource.build({type:"OPAQUE",value:"hex:"+t.presharedKey})}else o[r+"/2"].value=3;t.serverHost&&t.serverPort?o[r+"/0"].value=""+n+t.serverHost+":"+t.serverPort:o[r+"/0"].value="",o[r+"/1"].value=!!t.requestBootstrap,o[r+"/10"].value=t.serverId,o[r+"/11"].value=t.clientHoldOffTime||10}},{key:"_applyOptionsToServerObject",value:function(e,t,o){var r="/"+_objectCommon.LWM2M_OBJECT_ID.SERVER+"/"+e[_objectCommon.LWM2M_OBJECT_ID.SERVER];o[r+"/0"].value=t.serverId,o[r+"/1"].value=t.lifetimeSec}},{key:"_applyOptionsToACLObject",value:function(e,n,s){e[_objectCommon.LWM2M_OBJECT_ID.ACL].forEach(function(e){var t="/"+_objectCommon.LWM2M_OBJECT_ID.ACL+"/"+e,o=s[t+"/3"].toInteger(),r=s[t+"/2"].value[o];r?(delete s[t+"/2"].value[o],s[t+"/2"].value[n.serverId]=r):s[t+"/2"].value[n.serverId]=Resource.build({type:"INTEGER",value:_objectCommon.ACL.ALL}),s[t+"/3"].value=n.serverId})}}],[{key:"destroy",value:function(o){return o?Promise.all(Object.keys(o).filter(function(e){return/^\/[0-9\/]+/.test(e)}).map(function(e){var t=o[e];if(t.destroy&&"function"==typeof t.destroy)return t.destroy().catch(function(e){})})):Promise.resolve()}}]),i}(),RequestHandler=exports.RequestHandler=function(){function r(e,t){var o=2<arguments.length&&void 0!==arguments[2]?arguments[2]:Buffer.from([]);_classCallCheck(this,r),this.client=e,this.command=t,1===(this.payload=o)[0]?this.isRequest=!0:2===o[0]&&(this.isRequest=!1),this.messageId=o[1],this.objectId=o[2]+(o[3]<<8&65280),this.objectInstanceId=o[4]+(o[5]<<8&65280),this.resourceLen=o[6]+(o[7]<<8&65280),this.resources={},this.response=Buffer.concat([Buffer.from([2,this.messageId,_objectCommon.COAP_ERROR.COAP_NO_ERROR]),o.slice(2,8)])}return _createClass(r,[{key:"toJSONString",value:function(){return JSON.stringify(this,function(e,t){if("client"!==e)return t})}},{key:"setStatus",value:function(e){this.response[2]=255&e}},{key:"getStatus",value:function(){return this.response[2]}},{key:"setResourceLen",value:function(e){this.response[7]=255&e,this.response[8]=e>>8&255}},{key:"buildResponse",value:function(){var s=this,i=0,a=Buffer.from([]);Object.keys(this.resources).forEach(function(e){var t=parseInt(s.resources[e].uri.split("/")[3]);debug("[buildResponse()] this.resources[key] => "+JSON.stringify(s.resources[e])+", resourceId:"+t);var o=s.resources[e].value;if(o instanceof Resource)try{o.id=t;var r=o.serialize(a);r!==a&&(a=r,++i)}catch(e){var n={status:e.status||_objectCommon.COAP_ERROR.COAP_500_INTERNAL_SERVER_ERROR,message:e.message};s.setStatus(n.status),e.stack&&s.client.log(e.stack),s.client.error("lwm2m error",{payload:n})}}),this.getStatus()<_objectCommon.COAP_ERROR.COAP_400_BAD_REQUEST&&(this.response=Buffer.concat([this.response,a]),this.setResourceLen(i))}},{key:"perform",value:function(){var e=this.response.toString("base64"),t="/resp:"+this.command+":"+e.length+":"+e;return Promise.resolve({status:this.getStatus(),payload:t})}}]),r}(),IgnoreRequest=function(e){function r(e,t){_classCallCheck(this,r);var o=_possibleConstructorReturn(this,(r.__proto__||Object.getPrototypeOf(r)).call(this,e,t));return o.setStatus(_objectCommon.COAP_ERROR.COAP_IGNORE),o.client.log("[Ignore] Ignore Unknown Request:"+t),o}return _inherits(r,RequestHandler),r}(),Read=function(e){function u(e,t,o){_classCallCheck(this,u);var r=_possibleConstructorReturn(this,(u.__proto__||Object.getPrototypeOf(u)).call(this,e,t,o));if(0<r.resourceLen){for(var n=[],s=0;s<r.resourceLen;s++){var i=8+2*s,a=o[i]+(o[i+1]<<8&65280);n.push(Resource.build(a))}r.uris=n.map(function(e){var t="^/"+r.objectId+"/"+r.objectInstanceId+"/"+e.id+"$";return r.resources[t]=e,t})}else r.uris=["^/"+r.objectId+"/"+r.objectInstanceId+"/[0-9]+$"];return _get(u.prototype.__proto__||Object.getPrototypeOf(u.prototype),"setStatus",r).call(r,_objectCommon.COAP_ERROR.COAP_205_CONTENT),r}return _inherits(u,RequestHandler),_createClass(u,[{key:"perform",value:function(){var o=this;return this.client.objectStore.remoteGet(this.uris).then(function(e){var t=e.length;return 0===t?_get(u.prototype.__proto__||Object.getPrototypeOf(u.prototype),"setStatus",o).call(o,_objectCommon.COAP_ERROR.COAP_404_NOT_FOUND):1!==t||_objectCommon.ACL.isAllowed(_objectCommon.ACL.toValue(e[0].value.acl),_objectCommon.ACL.READABLE)?(o.client.debug("<Read> uris=>"+o.uris+", response=>"+JSON.stringify(e)),o.resources=e||[],o.buildResponse()):o.setStatus(_objectCommon.COAP_ERROR.COAP_405_METHOD_NOT_ALLOWED),_get(u.prototype.__proto__||Object.getPrototypeOf(u.prototype),"perform",o).call(o)}).catch(function(e){var t={status:e.status||_objectCommon.COAP_ERROR.COAP_400_BAD_REQUEST,message:e.message};return o.client.log("[Read] ("+o.uris+") Error Message:"+(t.message||""),{payload:t}),_get(u.prototype.__proto__||Object.getPrototypeOf(u.prototype),"setResourceLen",o).call(o,0),_get(u.prototype.__proto__||Object.getPrototypeOf(u.prototype),"setStatus",o).call(o,t.status),_get(u.prototype.__proto__||Object.getPrototypeOf(u.prototype),"perform",o).call(o)})}}]),u}(),Write=function(e){function i(e,t,o){_classCallCheck(this,i);var r=_possibleConstructorReturn(this,(i.__proto__||Object.getPrototypeOf(i)).call(this,e,t,o));r.params={};for(var n={},s=o.slice(8);0<s.length;)s=Resource.parse(n,s);return Object.keys(n).forEach(function(e){var t=n[e],o="/"+r.objectId+"/"+r.objectInstanceId+"/"+t.id;r.params[o]=t}),_get(i.prototype.__proto__||Object.getPrototypeOf(i.prototype),"setStatus",r).call(r,_objectCommon.COAP_ERROR.COAP_204_CHANGED),r}return _inherits(i,RequestHandler),_createClass(i,[{key:"perform",value:function(){var t=this;return _get(i.prototype.__proto__||Object.getPrototypeOf(i.prototype),"setResourceLen",this).call(this,0),this.client.debug("<Write> this.params=>"+JSON.stringify(this.params)),this.client.objectStore.remoteWrite(this.params).then(function(){return _get(i.prototype.__proto__||Object.getPrototypeOf(i.prototype),"perform",t).call(t)}).catch(function(e){return t.client.log("[Write] ("+JSON.stringify(t.params)+") URI:"+e.uri+" Error Message:"+(e.message||""),{payload:e}),_get(i.prototype.__proto__||Object.getPrototypeOf(i.prototype),"setStatus",t).call(t,e.status||_objectCommon.COAP_ERROR.COAP_400_BAD_REQUEST),_get(i.prototype.__proto__||Object.getPrototypeOf(i.prototype),"perform",t).call(t)})}}]),i}(),Execute=function(e){function n(e,t,o){_classCallCheck(this,n);var r=_possibleConstructorReturn(this,(n.__proto__||Object.getPrototypeOf(n)).call(this,e,t,o));return r.resourceId=o[8]+(o[9]<<8&65280),r.param=o.slice(10),0===r.param.length&&(r.param=null),_get(n.prototype.__proto__||Object.getPrototypeOf(n.prototype),"setStatus",r).call(r,_objectCommon.COAP_ERROR.COAP_204_CHANGED),r}return _inherits(n,RequestHandler),_createClass(n,[{key:"perform",value:function(){var t=this;_get(n.prototype.__proto__||Object.getPrototypeOf(n.prototype),"setResourceLen",this).call(this,0);var o="/"+this.objectId+"/"+this.objectInstanceId+"/"+this.resourceId;return this.client.objectStore.remoteExecute(o,this.param).then(function(){return _get(n.prototype.__proto__||Object.getPrototypeOf(n.prototype),"perform",t).call(t)}).catch(function(e){return t.client.log("[Execute] ("+o+") Error Message:"+(e.message||""),{payload:e}),_get(n.prototype.__proto__||Object.getPrototypeOf(n.prototype),"setStatus",t).call(t,e.status||_objectCommon.COAP_ERROR.COAP_400_BAD_REQUEST),_get(n.prototype.__proto__||Object.getPrototypeOf(n.prototype),"perform",t).call(t)})}}]),n}(),StateChanged=function(e){function n(e,t,o){_classCallCheck(this,n);var r=_possibleConstructorReturn(this,(n.__proto__||Object.getPrototypeOf(n)).call(this,e,t));return r.stateLabel=o.toString(),r.client.debug("[StateChanged] state=>"+r.stateLabel),r}return _inherits(n,RequestHandler),_createClass(n,[{key:"perform",value:function(){var e=n.STATE_TABLE[this.stateLabel];return e&&this.client.state!==e&&(this.client.previousState=this.client.state,this.client.state=e,this.client.emit(e)),Promise.resolve({status:_objectCommon.COAP_ERROR.COAP_IGNORE})}}]),n}();StateChanged.STATE_TABLE={STATE_INITIAL:"started",STATE_BOOTSTRAP_REQUIRED:"bootstrapRequired",STATE_BOOTSTRAPPING:"bootstrapping",STATE_REGISTER_REQUIRED:"registerRequired",STATE_REGISTERING:"registering",STATE_READY:"connected"};var Observe=function(e){function o(e,t){return _classCallCheck(this,o),_possibleConstructorReturn(this,(o.__proto__||Object.getPrototypeOf(o)).call(this,e,t))}return _inherits(o,RequestHandler),_createClass(o,[{key:"buildResponse",value:function(e){var t=Buffer.from([255&e.length,e.length>>8&255]);e.forEach(function(e){t=Buffer.concat([t,Buffer.from([255&e.length,e.length>>8&255]),Buffer.from(e)])}),this.response=Buffer.concat([this.response,t])}},{key:"perform",value:function(){var e=this.client.getUpdatedUrisAndReset();return this.client.debug("[Observe] # of updated uris:"+e.length),0<e.length?(this.buildResponse(e),_get(o.prototype.__proto__||Object.getPrototypeOf(o.prototype),"perform",this).call(this)):Promise.resolve({status:_objectCommon.COAP_ERROR.COAP_IGNORE})}}]),o}(),Discover=function(e){function t(){return _classCallCheck(this,t),_possibleConstructorReturn(this,(t.__proto__||Object.getPrototypeOf(t)).apply(this,arguments))}return _inherits(t,Read),_createClass(t,[{key:"buildResponse",value:function(){var t=[];this.resources.map(function(e){return parseInt(e.uri.split("/")[3])}).sort(function(e,t){return e-t}).forEach(function(e){t.push(255&e),t.push(e>>8&255)}),this.getStatus()<_objectCommon.COAP_ERROR.COAP_400_BAD_REQUEST&&(this.response=Buffer.concat([this.response,Buffer.from(t)]),this.setResourceLen(this.resources.length))}}]),t}(),Create=function(e){function i(e,t,o){_classCallCheck(this,i);var r=_possibleConstructorReturn(this,(i.__proto__||Object.getPrototypeOf(i)).call(this,e,t,o));r.params={};for(var n={},s=o.slice(8);0<s.length;)s=Resource.parse(n,s);return Object.keys(n).forEach(function(e){var t=n[e],o="/"+r.objectId+"/"+r.objectInstanceId+"/"+t.id;r.params[o]=t}),_get(i.prototype.__proto__||Object.getPrototypeOf(i.prototype),"setStatus",r).call(r,_objectCommon.COAP_ERROR.COAP_201_CREATED),r}return _inherits(i,RequestHandler),_createClass(i,[{key:"perform",value:function(){var t=this;return _get(i.prototype.__proto__||Object.getPrototypeOf(i.prototype),"setResourceLen",this).call(this,0),this.client.debug("<Create> this.params=>"+JSON.stringify(this.params)),this.client.objectStore.remoteCreate(this.params).then(function(){return _get(i.prototype.__proto__||Object.getPrototypeOf(i.prototype),"perform",t).call(t)}).catch(function(e){return t.client.log("[Create] ("+JSON.stringify(t.params)+") Error Message:"+(e.message||""),{payload:e}),_get(i.prototype.__proto__||Object.getPrototypeOf(i.prototype),"setStatus",t).call(t,e.status||_objectCommon.COAP_ERROR.COAP_400_BAD_REQUEST),_get(i.prototype.__proto__||Object.getPrototypeOf(i.prototype),"perform",t).call(t)})}}]),i}(),Delete=function(e){function n(e,t,o){_classCallCheck(this,n);var r=_possibleConstructorReturn(this,(n.__proto__||Object.getPrototypeOf(n)).call(this,e,t,o));return r.param="^/"+r.objectId+"/"+r.objectInstanceId+"/[0-9]+$",_get(n.prototype.__proto__||Object.getPrototypeOf(n.prototype),"setStatus",r).call(r,_objectCommon.COAP_ERROR.COAP_202_DELETED),r}return _inherits(n,RequestHandler),_createClass(n,[{key:"perform",value:function(){var t=this;return _get(n.prototype.__proto__||Object.getPrototypeOf(n.prototype),"setResourceLen",this).call(this,0),this.client.debug("<Delete> this.params=>"+this.param),this.client.objectStore.remoteDelete(this.param).then(function(){return _get(n.prototype.__proto__||Object.getPrototypeOf(n.prototype),"perform",t).call(t)}).catch(function(e){return t.client.log("[Delete] ("+t.param+") Error Message:"+(e.message||""),{payload:e}),_get(n.prototype.__proto__||Object.getPrototypeOf(n.prototype),"setStatus",t).call(t,e.status||_objectCommon.COAP_ERROR.COAP_400_BAD_REQUEST),_get(n.prototype.__proto__||Object.getPrototypeOf(n.prototype),"perform",t).call(t)})}}]),n}(),Backup=function(e){function r(e,t,o){return _classCallCheck(this,r),_possibleConstructorReturn(this,(r.__proto__||Object.getPrototypeOf(r)).call(this,e,t,o))}return _inherits(r,RequestHandler),_createClass(r,[{key:"perform",value:function(){var t=this;return _get(r.prototype.__proto__||Object.getPrototypeOf(r.prototype),"setResourceLen",this).call(this,0),this.client.debug("<Backup> this.objectId=>"+this.objectId),this.client.objectStore.backup(this.objectId).then(function(){return _get(r.prototype.__proto__||Object.getPrototypeOf(r.prototype),"perform",t).call(t)}).catch(function(e){return t.client.log("[Backup] (/"+t.objectId+") Error Message:"+(e.message||""),{payload:e}),_get(r.prototype.__proto__||Object.getPrototypeOf(r.prototype),"setStatus",t).call(t,e.status||_objectCommon.COAP_ERROR.COAP_400_BAD_REQUEST),_get(r.prototype.__proto__||Object.getPrototypeOf(r.prototype),"perform",t).call(t)})}}]),r}(),Restore=function(e){function r(e,t,o){return _classCallCheck(this,r),_possibleConstructorReturn(this,(r.__proto__||Object.getPrototypeOf(r)).call(this,e,t,o))}return _inherits(r,RequestHandler),_createClass(r,[{key:"perform",value:function(){var t=this;return _get(r.prototype.__proto__||Object.getPrototypeOf(r.prototype),"setResourceLen",this).call(this,0),this.client.debug("<Restore> this.objectId=>"+this.objectId),this.client.objectStore.restore(this.objectId).then(function(){return _get(r.prototype.__proto__||Object.getPrototypeOf(r.prototype),"perform",t).call(t)}).catch(function(e){return t.client.log("[Restore] (/"+t.objectId+") Error Message:"+(e.message||""),{payload:e}),_get(r.prototype.__proto__||Object.getPrototypeOf(r.prototype),"setStatus",t).call(t,e.status||_objectCommon.COAP_ERROR.COAP_400_BAD_REQUEST),_get(r.prototype.__proto__||Object.getPrototypeOf(r.prototype),"perform",t).call(t)})}}]),r}(),ReadInstances=function(){function r(e,t,o){_classCallCheck(this,r),this.client=e,this.command=t,1===(this.payload=o)[0]?this.isRequest=!0:2===o[0]&&(this.isRequest=!1),this.messageId=o[1],this.objectId=o[2]+(o[3]<<8&65280),this.response=Buffer.from([2,this.messageId,_objectCommon.COAP_ERROR.COAP_205_CONTENT,o[2],o[3],0,0]),this.uris=["^/"+this.objectId+"/[0-9]+/[0-9]+$"]}return _createClass(r,[{key:"toJSONString",value:function(){return JSON.stringify(this,function(e,t){if("client"!==e)return t})}},{key:"setStatus",value:function(e){this.response[2]=255&e}},{key:"getStatus",value:function(){return this.response[2]}},{key:"sendResponse",value:function(){var e=this.response.toString("base64"),t="/resp:"+this.command+":"+e.length+":"+e;return Promise.resolve({status:this.getStatus(),payload:t})}},{key:"resolveInstanceIdList",value:function(e){var r=[];return e.forEach(function(e){var t=e.uri,o=parseInt(t.substring(1+t.indexOf("/",1),t.lastIndexOf("/")));r.indexOf(o)<0&&r.push(o)}),r}},{key:"perform",value:function(){var r=this;return this.client.objectStore.remoteGet(this.uris).then(function(e){if(0===e.length)return r.client.debug("<ReadInstances> No resource for objectId="+r.objectId),r.setStatus(_objectCommon.COAP_ERROR.COAP_404_NOT_FOUND),r.sendResponse();r.client.debug("<ReadInstances> uris=>"+r.uris+", response=>"+JSON.stringify(e));var t=r.resolveInstanceIdList(e);if(0===t.length)return r.client.debug("<ReadInstances> No instance for objectId="+r.objectId),r.setStatus(_objectCommon.COAP_ERROR.COAP_404_NOT_FOUND),r.sendResponse();r.client.debug("<ReadInstances> Instance ID(s): "+JSON.stringify(t)+" found in objectId="+r.objectId),r.response[5]=255&t.length,r.response[6]=t.length>>8&255;var o=r.response;return t.forEach(function(e){o=Buffer.concat([o,Buffer.from([255&e,e>>8&255])])}),r.response=o,r.sendResponse()}).catch(function(e){var t={status:e.status||_objectCommon.COAP_ERROR.COAP_400_BAD_REQUEST,message:e.message};return r.client.debug("<ReadInstances> error => "+e.message+" "+e.stack),r.client.log("[ReadInstances] ("+r.uris+") Error Message:"+(t.message||""),{payload:t}),r.setStatus(t.status),r.sendResponse()})}}]),r}(),HeartbeatRequest=function(e){function r(e,t){_classCallCheck(this,r);var o=_possibleConstructorReturn(this,(r.__proto__||Object.getPrototypeOf(r)).call(this,e,t));return o.setStatus(_objectCommon.COAP_ERROR.COAP_IGNORE),o.client.ping(),o}return _inherits(r,RequestHandler),r}();RequestHandler.build=function(e,t,o){switch(t){case"heartbeat":return new HeartbeatRequest(e,t);case"read":return new Read(e,t,o);case"write":return new Write(e,t,o);case"execute":return new Execute(e,t,o);case"create":return new Create(e,t,o);case"delete":return new Delete(e,t,o);case"discover":return new Discover(e,t,o);case"observe":return new Observe(e,t);case"backup":return new Backup(e,t,o);case"restore":return new Restore(e,t,o);case"stateChanged":return new StateChanged(e,t,o);case"readInstances":return new ReadInstances(e,t,o);default:return new IgnoreRequest(e,t)}};exports.LwM2MClientProxy=function(e){function t(){var e=0<arguments.length&&void 0!==arguments[0]?arguments[0]:{};_classCallCheck(this,t);var o=_possibleConstructorReturn(this,(t.__proto__||Object.getPrototypeOf(t)).call(this));return o.clientName=e.clientName,o.clientPort=e.clientPort,o.useIPv4=e.useIPv4,o.log=e.log?e.log.bind(e):console.log,o.trace=e.trace?e.trace.bind(e):console.log,o.debug=e.debug?e.debug.bind(e):console.log,o.error=e.error?e.error.bind(e):console.error,o.objectStore=e.objectStore||{},o.requestBootstrap=e.requestBootstrap,o.saveProvisionedConfig=e.saveProvisionedConfig,o.reconnectSec=e.reconnectSec||60,o.bootstrapIntervalSec=e.bootstrapIntervalSec||3600,o.redirectLwm2mClientLog=e.redirectLwm2mClientLog,o.dumpLwm2mMessages=e.dumpLwm2mMessages,o.autoReconnect=0<o.reconnectSec,o.autoReconnectTask=null,o.previousState=null,o.state=StateChanged.STATE_TABLE.STATE_INITIAL,o.credentialFilePath=e.credentialFilePath,o.secret=e.secret,o.lastPingAt=0,o.maxRecvPacketSize=e.maxRecvPacketSize||16486,o.maxRecvPacketSize<16486?o.maxRecvPacketSize=16486:65535<o.maxRecvPacketSize&&(o.maxRecvPacketSize=65535),o.saveProvisionedConfig||(CredUtils.deleteCredentials(o.credentialFilePath),o.debug("<stdout> [saveProvisionedConfig=>false] Deleting credentials file!")),o.on(StateChanged.STATE_TABLE.STATE_BOOTSTRAPPING,function(){var e=CredUtils.deleteCredentials(o.credentialFilePath);o.debug("<stdout> Deleting credentials file => "+(e?"OK":"FAIL")+"!"),o.objectStore.emitClientStateChanged("bootstrapping")}),o.on(StateChanged.STATE_TABLE.STATE_READY,function(){o.requestBootstrap&&o.saveProvisionedConfig&&o.objectStore.createCredentials().then(function(e){var t=CredUtils.saveCredentials(o.credentialFilePath,o.secret,e);o.debug("<stdout> Saving credentials file => "+(t?"OK":"FAIL")+"!")}),o.objectStore.updateServerId(),o.objectStore.emitClientStateChanged("ready")}),o}return _inherits(t,_events.EventEmitter),_createClass(t,[{key:"getUpdatedUrisAndReset",value:function(){var e=this.objectStore.updatedUris||[];return this.objectStore.updatedUris=[],e}},{key:"isConnected",value:function(){return!!this.cproc}},{key:"shutdown",value:function(){var t=this,o=0<arguments.length&&void 0!==arguments[0]?arguments[0]:{deregister:!0};this.hearbeatMonitor&&clearTimeout(this.hearbeatMonitor),this.autoReconnect=!1,this.autoReconnectTask&&(clearTimeout(this.autoReconnectTask),this.autoReconnectTask=null);var r=this.isConnected();return new Promise(function(e){if(!r)return e();t.cproc.kill(o.deregister?"SIGINT":"SIGTERM"),t.once("disconnected",function(){return e(!0)})}).then(function(){if(t.objectStore)return t.objectStore.shutdown()})}},{key:"ping",value:function(){this.lastPingAt=Date.now()}},{key:"start",value:function(){var i=this,e=_path2.default.join(__dirname,"binding","wakatiwaiclient"),t=[];"true"===process.env.ENABLE_VALGRIND&&(t.push("--leak-check=yes"),t.push(e),e="valgrind"),t.push("-n"),t.push(this.clientName),this.useIPv4&&t.push("-4"),this.redirectLwm2mClientLog&&this.dumpLwm2mMessages&&t.push("-d"),t.push("-l"),t.push(this.clientPort),t.push("-o"),t.push(this.objectStore.getExtraObjectIDArray().join(",")),t.push("-s"),t.push(this.maxRecvPacketSize),this.cproc=_child_process2.default.spawn(e,t,{cwd:process.cwd(),env:process.env,stdio:["pipe","pipe",this.redirectLwm2mClientLog?process.stderr:"ignore"]}),this.autoReconnectTask&&(clearTimeout(this.autoReconnectTask),this.autoReconnectTask=null),this.cproc.on("exit",function(e){var t="bootstrapping"!==i.state?i.reconnectSec:i.bootstrapIntervalSec;i.log("Process Exit: pid => "+i.cproc.pid+", code => "+e+", state => "+i.state+", autoReconnect => "+i.autoReconnect+" (after "+t+" sec.)"),i.cproc=null,i.emit("disconnected",i.state),i.autoReconnect&&(i.autoReconnectTask=setTimeout(function(){i.start()},1e3*t))}),this.cproc.stdout.on("data",function(e){var t=e.toString().split(/[\r\n]+/).filter(function(e){return e.trim()});i.trace("<stdout> [Request] "+t.length+" lines, => "+t);var o,r=t.map(function(e){var t=!1;i.payload?i.payload+=e:(i.payload=e,t=!0);var o=i.payload.split(":"),r=o[0];if(!r||void 0===o[1]||void 0===o[2])return t&&(i.payload=null),Promise.resolve();var n=parseInt(o[1]);if(n>o[2].length)return i.debug("<stdout> [Request] bodyLen (expected): "+n+", current: "+o[2].length),Promise.resolve();i.payload=null,r=r.substring(1);var s=RequestHandler.build(i,r,Buffer.from(o[2],"base64"));return i.trace("<stdout> request => "+s.toJSONString()),s.perform().then(function(e){e.status!==_objectCommon.COAP_ERROR.COAP_IGNORE&&i.cproc.stdin.write(e.payload),i.trace("<stdout> [Response:done] status:"+_objectCommon.COAP_ERROR.toString(e.status))}).catch(function(e){i.cproc.stdin.write(e.payload||e.toString()),i.trace("<stdout> [Response:error] "+(e.payload?JSON.stringify(e):e.stack))})});(o=r,o.reduce(function(e,t){return e.then(function(e){return t.then(Array.prototype.concat.bind(e))})},Promise.resolve([]))).then(function(){i.trace("<stdout> [Request] Done")}).catch(function(e){i.log(e)})});!function e(){i.hearbeatMonitor=setTimeout(function(){i.isConnected()&&9e4<=Date.now()-i.lastPingAt?(i.log("Kill the wakatiwai client as it is no longer responding."),i.cproc.kill("SIGKILL")):e()},9e4)}()}}]),t}(),exports.LwM2MObjectStore=function(){function t(e){_classCallCheck(this,t),this.repo=null,this.serverId=e.serverId,this.propagator=e,this.updatedUris=[],this.backupObjects={}}return _createClass(t,[{key:"shutdown",value:function(){return ResourceRepositoryBuilder.destroy(this.repo)}},{key:"getExtraObjectIDArray",value:function(){return this.repo?this.repo.extraObjectIdArray.slice():[]}},{key:"updateServerId",value:function(){var o=this;return this.get("/0/0/10").then(function(e){var t=e[0].value.value;return o.serverId=t})}},{key:"createCredentials",value:function(){return this.repo?this.get("/(0|1|2)/.*").then(function(e){var r={};return e.forEach(function(e){var t=e.uri.split("/");r[t[1]]||(r[t[1]]={});var o=r[t[1]];o[t[2]]||(o[t[2]]={}),o[t[2]][t[3]]=e.value}),r}):Promise.resolve([])}},{key:"emit",value:function(e,t,o,r){this.propagator.emit("object-event",{serverId:r?this.serverId:void 0,uri:e,value:t,eventType:o,remote:r,ts:Date.now()})}},{key:"emitClientStateChanged",value:function(e){this.propagator.emit("clientStateChanged",e)}},{key:"backup",value:function(t){var o=this;return this.get("^/"+t+"/.*$").then(function(e){o.backupObjects[t]={repo:e},o.emit("/"+t,o.backupObjects[t],"backedUp",!1)})}},{key:"restore",value:function(e){var o=this,t=this.backupObjects[e];return t?(delete this.backupObjects[e],this.delete("^/"+e+"/.*$").catch(function(e){if(e.status!==_objectCommon.COAP_ERROR.COAP_404_NOT_FOUND)return Promise.reject(e)}).then(function(){return Promise.all(t.repo.map(function(t){return Resource.from(t.value).then(function(e){o.repo[t.uri]=e})})).then(function(){o.emit("/"+e,t,"restored",!1)})})):Promise.resolve()}},{key:"_verifyValues",value:function(e){var t=this.repo[e];t&&e.match("^/1/[0-9]+/1$")&&t.toInteger()<30&&(t.value=30)}},{key:"write",value:function(s,o,i){var a=this;if(!this.repo)return new Promise(function(e,t){setTimeout(function(){a.write(s,o,i).then(function(){return e()}).catch(function(e){return t(e)})},500)});if(s){var e=this.repo[s];return(void 0===e?Resource.from(o).then(function(e){var t=s.split("/").splice(1),o=a.repo.definitions[t[0]];if(o){var r=o[t[2]];if(r){var n=e;return e=r.clone(),(a.repo[s]=e).update(n,i?a.serverId:void 0)}}a.repo[s]=e}):e.update(o,i?this.serverId:void 0)).then(function(){return a._verifyValues(s),a.updatedUris.indexOf(s)<0&&a.updatedUris.push(s),a.emit(s,e,"updated",i),Promise.resolve()}).catch(function(e){return e.uri=s,e.value=o,e.operation="write",Promise.reject(e)})}return Promise.reject({status:_objectCommon.COAP_ERROR.COAP_404_NOT_FOUND,message:"Not Found",operation:"write",uri:s,value:o})}},{key:"execute",value:function(o,r,n){var s=this;return this.repo?o&&this.repo[o]?this.repo[o].isExecutable()?(this.emit(o,r,"executed",n),Promise.resolve()):Promise.reject({status:_objectCommon.COAP_ERROR.COAP_405_METHOD_NOT_ALLOWED,message:"Method Not Allowed",operation:"execute",uri:o,value:r}):Promise.reject({status:_objectCommon.COAP_ERROR.COAP_404_NOT_FOUND,message:"Not Found",operation:"execute",uri:o,value:r}):new Promise(function(e,t){setTimeout(function(){s.execute(o,r,n).then(function(){return e()}).catch(function(e){return t(e)})},500)})}},{key:"_normalizeUriRegEx",value:function(e){return"^"!==e.charAt(0)&&(e="^"+e),e.indexOf("$")<0&&(e+="$"),e}},{key:"get",value:function(r){var n=this,s=1<arguments.length&&void 0!==arguments[1]?arguments[1]:[],i=2<arguments.length&&void 0!==arguments[2]&&arguments[2];return this.repo?r&&(r=this._normalizeUriRegEx(r),Object.keys(this.repo).sort().map(function(e){if(e.match(r)){if(i&&n.repo.hideSensitiveInfo&&n.repo[e].sensitive)return;s.push({uri:e,value:i?n.repo[e].clone():n.repo[e].toJSON()})}}),0<s.length)?Promise.resolve(s):Promise.reject({status:_objectCommon.COAP_ERROR.COAP_404_NOT_FOUND,message:"Not Found",operation:"read",uriRegEx:r}):new Promise(function(t,o){setTimeout(function(){n.get(r,s,i).then(function(e){return t(e)}).catch(function(e){return o(e)})},500)})}},{key:"create",value:function(s,o,i){var a=this;return this.repo?s?Resource.from(o).then(function(e){var t=s.split("/").splice(1),o=a.repo.definitions[t[0]];if(o){var r=o[t[2]];if(r){var n=e;return(e=r.clone()).update(n,i?a.serverId:void 0).then(function(){return e})}}return Promise.resolve(e)}).then(function(e){return a.repo[s]=e,a._verifyValues(s),a.updatedUris.indexOf(s)<0&&a.updatedUris.push(s),a.emit(s,a.repo[s],"created",i),Promise.resolve()}):Promise.reject({status:_objectCommon.COAP_ERROR.COAP_404_NOT_FOUND,message:"Not Found",operation:"create",uri:s,value:o}):new Promise(function(e,t){setTimeout(function(){a.create(s,o,i).then(function(){return e()}).catch(function(e){return t(e)})},500)})}},{key:"delete",value:function(o,r){var n=this;if(!this.repo)return new Promise(function(e,t){setTimeout(function(){n.delete(o,r).then(function(){return e()}).catch(function(e){return t(e)})},500)});if(o){o=this._normalizeUriRegEx(o);var e=Object.keys(this.repo).map(function(e){if(e.match(o))return e}).filter(function(e){return e});if(0<e.length){var t=0;return e.forEach(function(e){!r||n.repo[e].isDeletable()?(n.updatedUris.indexOf(e)<0&&n.updatedUris.push(e),n.repo[e]&&(n.repo[e].destroy(),delete n.repo[e],n.emit(e,null,"deleted",r))):t++}),0<t&&e.length===t?Promise.reject({status:_objectCommon.COAP_ERROR.COAP_401_UNAUTHORIZED,message:"Unauthorized (insufficient permission)",operation:"delete",uri:e[0]}):Promise.resolve()}}return Promise.reject({status:_objectCommon.COAP_ERROR.COAP_404_NOT_FOUND,message:"Not Found",operation:"delete",uriRegEx:o})}},{key:"remoteWrite",value:function(o){var r=this;return o&&0<Object.keys(o).length?Promise.all(Object.keys(o).map(function(e){var t=o[e];return r.write(e,t,!0)})):Promise.reject({status:_objectCommon.COAP_ERROR.COAP_400_BAD_REQUEST})}},{key:"remoteExecute",value:function(e,t){return e?this.execute(e,t,!0):Promise.reject({status:_objectCommon.COAP_ERROR.COAP_404_NOT_FOUND})}},{key:"remoteGet",value:function(e){var t=this;if(e&&0<e.length){var o=[];return Promise.all(e.map(function(e){return t.get(e,o,!0)})).then(function(){return Promise.resolve(o)})}return Promise.reject({status:_objectCommon.COAP_ERROR.COAP_400_BAD_REQUEST})}},{key:"remoteCreate",value:function(o){var r=this;return o&&0<Object.keys(o).length?Promise.all(Object.keys(o).map(function(e){var t=o[e];return r.create(e,t,!0)})):Promise.reject({status:_objectCommon.COAP_ERROR.COAP_404_NOT_FOUND})}},{key:"remoteDelete",value:function(e){return e?this.delete(e,!0):Promise.reject({status:_objectCommon.COAP_ERROR.COAP_404_NOT_FOUND})}}]),t}();